diff --git a/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java b/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
index 7d52fc8..708ef2d 100644
--- a/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
+++ b/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
@@ -110,6 +110,8 @@ import netscape.security.x509.CertificateVersion;
 import netscape.security.x509.CertificateX509Key;
 import netscape.security.x509.Extension;
 import netscape.security.x509.Extensions;
+import netscape.security.x509.PKIXExtensions;
+import netscape.security.x509.SubjectKeyIdentifierExtension;
 import netscape.security.x509.X500Name;
 import netscape.security.x509.X509CertImpl;
 import netscape.security.x509.X509CertInfo;
@@ -776,7 +778,8 @@ public abstract class EnrollProfile extends BasicProfile
                         }
                     } else if (id_cmc_identityProofV2 && (attr != null)) {
                         // either V2 or not V2; can't be both
-                        CMS.debug(method + "not pre-signed CMC request; calling verifyIdentityProofV2;");
+                        CMS.debug(method +
+                                "not pre-signed CMC request; calling verifyIdentityProofV2;");
                         if (!id_cmc_identification) {
                             SEQUENCE bpids = getRequestBpids(reqSeq);
                             context.put("identification", bpids);
@@ -788,7 +791,7 @@ public abstract class EnrollProfile extends BasicProfile
                                             msg);
                         }
 
-                        boolean valid = verifyIdentityProofV2(attr, ident_s,
+                        boolean valid = verifyIdentityProofV2(context, attr, ident_s,
                                 reqSeq);
                         if (!valid) {
                             SEQUENCE bpids = getRequestBpids(reqSeq);
@@ -877,6 +880,11 @@ public abstract class EnrollProfile extends BasicProfile
                 String configName = "cmc.popLinkWitnessRequired";
                 CMS.debug(method + "getting :" + configName);
                 popLinkWitnessRequired = CMS.getConfigStore().getBoolean(configName, false);
+                if (popLinkWitnessRequired) {
+                    CMS.debug(method + "popLinkWitness(V2) required");
+                } else {
+                    CMS.debug(method + "popLinkWitness(V2) not required");
+                }
             } catch (Exception e) {
                 // unlikely to get here
                 msg = method + " Failed to retrieve cmc.popLinkWitnessRequired";
@@ -1441,22 +1449,44 @@ public abstract class EnrollProfile extends BasicProfile
      * @author cfu
      */
     private boolean verifyIdentityProofV2(
+            SessionContext sessionContext,
             TaggedAttribute attr,
             UTF8String ident,
             SEQUENCE reqSeq) {
         String method = "EnrollProfile:verifyIdentityProofV2: ";
+        String msg = "";
         CMS.debug(method + " begins");
+        boolean verified = false;
+        String auditMessage = method;
+
         if ((attr == null) ||
                 (ident == null) ||
                 (reqSeq == null)) {
             CMS.debug(method + "method parameters cannot be null");
+            // this is internal error
             return false;
         }
 
         String ident_string = ident.toString();
+        String auditAttemptedCred = null;
+//cfu test only
+            auditMessage = CMS.getLogMessage(
+                    AuditEvent.CMC_PROOF_OF_IDENTIFICATION_FAILURE,
+                    auditAttemptedCred,
+                    ILogger.FAILURE,
+                    method + msg);
+            audit(auditMessage);
 
         SET vals = attr.getValues(); // getting the IdentityProofV2 structure
         if (vals.size() < 1) {
+            msg = " invalid TaggedAttribute in request";
+            CMS.debug(method + msg);
+            auditMessage = CMS.getLogMessage(
+                    AuditEvent.CMC_PROOF_OF_IDENTIFICATION_FAILURE,
+                    auditAttemptedCred,
+                    ILogger.FAILURE,
+                    method + msg);
+            audit(auditMessage);
             return false;
         }
 
@@ -1464,18 +1494,33 @@ public abstract class EnrollProfile extends BasicProfile
         ISharedToken tokenClass = getSharedTokenClass(configName);
 
         if (tokenClass == null) {
-            CMS.debug(method + " Failed to retrieve shared secret plugin class");
+            msg = " Failed to retrieve shared secret plugin class";
+            CMS.debug(method + msg);
+            auditMessage = CMS.getLogMessage(
+                    AuditEvent.CMC_PROOF_OF_IDENTIFICATION_FAILURE,
+                    auditAttemptedCred,
+                    ILogger.FAILURE,
+                    method + msg);
+            audit(auditMessage);
             return false;
         }
 
         String token = null;
-        if (ident_string != null)
+        if (ident_string != null) {
+            auditAttemptedCred = ident_string;
             token = tokenClass.getSharedToken(ident_string);
-        else
+        } else
             token = tokenClass.getSharedToken(mCMCData);
 
         if (token == null) {
-            CMS.debug(method + " Failed to retrieve shared secret");
+            msg = " Failed to retrieve shared secret";
+            CMS.debug(method + msg);
+            auditMessage = CMS.getLogMessage(
+                    AuditEvent.CMC_PROOF_OF_IDENTIFICATION_FAILURE,
+                    auditAttemptedCred,
+                    ILogger.FAILURE,
+                    method + msg);
+            audit(auditMessage);
             return false;
         }
 
@@ -1493,26 +1538,63 @@ public abstract class EnrollProfile extends BasicProfile
 
             OCTET_STRING witness = idV2val.getWitness();
             if (witness == null) {
-                CMS.debug(method + " witness reurned by idV2val.getWitness is null");
-                return false;
+                msg = " witness reurned by idV2val.getWitness is null";
+                CMS.debug(method + msg);
+                throw new EBaseException(msg);
             }
 
             byte[] witness_bytes = witness.toByteArray();
             byte[] request_bytes = ASN1Util.encode(reqSeq); // PKIData reqSequence field
-            return verifyDigest(
+            verified = verifyDigest(
                     (ident_string != null) ? (token + ident_string).getBytes() : token.getBytes(),
                     request_bytes,
                     witness_bytes,
                     hashAlg, macAlg);
+
+            String authMgrID =
+                    (String) sessionContext.get(SessionContext.AUTH_MANAGER_ID);
+            String auditSubjectID = null;
+
+            if (verified) {
+                // update auditSubjectID
+                if (sessionContext != null) {
+                    auditSubjectID = (String)
+                            sessionContext.get(SessionContext.USER_ID);
+                    CMS.debug(method + "current auditSubjectID was:"+ auditSubjectID);
+                    CMS.debug(method + "identity verified. Updating auditSubjectID");
+                    CMS.debug(method + "updated auditSubjectID is:"+ ident_string);
+                    auditSubjectID = ident_string;
+                    sessionContext.put(SessionContext.USER_ID, auditSubjectID);
+                } else { //very unlikely
+                    CMS.debug(method + "sessionContext null; cannot update auditSubjectID");
+                }
+
+                auditMessage = CMS.getLogMessage(
+                        AuditEvent.CMC_PROOF_OF_IDENTIFICATION_SUCCESS,
+                        auditSubjectID,
+                        ILogger.SUCCESS);
+                audit(auditMessage);
+            } else {
+                throw new EBaseException("failed to verify");
+            }
+            return verified;
         } catch (Exception e) {
             CMS.debug(method + " Failed with Exception: " + e.toString());
+            auditMessage = CMS.getLogMessage(
+                    AuditEvent.CMC_PROOF_OF_IDENTIFICATION_FAILURE,
+                    auditAttemptedCred,
+                    ILogger.FAILURE,
+                    method + e.toString());
+            audit(auditMessage);
             return false;
         }
 
     } // verifyIdentityProofV2
 
-    private boolean verifyIdentityProof(TaggedAttribute attr, SEQUENCE reqSeq) {
+    private boolean verifyIdentityProof(
+            TaggedAttribute attr, SEQUENCE reqSeq) {
         String method = "verifyIdentityProof: ";
+        boolean verified = false;
 
         SET vals = attr.getValues();
         if (vals.size() < 1)
@@ -1537,7 +1619,11 @@ public abstract class EnrollProfile extends BasicProfile
             byte[] b = ostr.toByteArray();
             byte[] text = ASN1Util.encode(reqSeq);
 
-            return verifyDigest(token.getBytes(), text, b);
+            verified = verifyDigest(token.getBytes(), text, b);
+            if (verified) {// update auditSubjectID
+                //placeholder. Should probably just disable this v1 method
+            }
+            return verified;
     }
 
     public void fillTaggedRequest(Locale locale, TaggedRequest tagreq, X509CertInfo info,
@@ -1592,13 +1678,21 @@ public abstract class EnrollProfile extends BasicProfile
 
                 p10.encode(ostream);
                 PKCS10 pkcs10 = new PKCS10(ostream.toByteArray(), sigver);
+                if (sigver) {
+                    auditMessage = CMS.getLogMessage(
+                            AuditEvent.PROOF_OF_POSSESSION_SUCCESS,
+                            auditSubjectID,
+                            ILogger.SUCCESS);
+                    audit(auditMessage);
+                }
 
                 req.setExtData("bodyPartId", tcr.getBodyPartID());
                 fillPKCS10(locale, pkcs10, info, req);
             } catch (Exception e) {
                 CMS.debug(method + e);
                 // this will throw
-                popFailed(locale, auditSubjectID, auditMessage, e);
+                if (sigver)
+                    popFailed(locale, auditSubjectID, auditMessage, e);
             }  finally {
                 if ((sigver == true) && (tokenSwitched == true)){
                     cm.setThreadToken(savedToken);
@@ -1787,8 +1881,9 @@ public abstract class EnrollProfile extends BasicProfile
     public void fillCertReqMsg(Locale locale, CertReqMsg certReqMsg, X509CertInfo info,
             IRequest req)
             throws EProfileException {
+        String method = "EnrollProfile: fillCertReqMsg: ";
         try {
-            CMS.debug("Start parseCertReqMsg ");
+            CMS.debug(method + "Start parseCertReqMsg ");
             CertRequest certReq = certReqMsg.getCertReq();
             req.setExtData("bodyPartId", certReq.getCertReqId());
             // handle PKIArchiveOption (key archival)
@@ -1897,12 +1992,20 @@ public abstract class EnrollProfile extends BasicProfile
                     extensions = new CertificateExtensions();
                 int numexts = certTemplate.numExtensions();
 
+                /*
+                 * there seems to be an issue with constructor in Extension
+                 * when feeding SubjectKeyIdentifierExtension;
+                 * Special-case it
+                 */
+                OBJECT_IDENTIFIER SKIoid =
+                        new OBJECT_IDENTIFIER(PKIXExtensions.SubjectKey_Id.toString());
                 for (int j = 0; j < numexts; j++) {
                     org.mozilla.jss.pkix.cert.Extension jssext =
                             certTemplate.extensionAt(j);
                     boolean isCritical = jssext.getCritical();
                     org.mozilla.jss.asn1.OBJECT_IDENTIFIER jssoid =
                             jssext.getExtnId();
+                    CMS.debug(method + "found extension:" + jssoid.toString());
                     long[] numbers = jssoid.getNumbers();
                     int[] oidNumbers = new int[numbers.length];
 
@@ -1919,8 +2022,14 @@ public abstract class EnrollProfile extends BasicProfile
                     jssvalue.encode(jssvalueout);
                     byte[] extValue = jssvalueout.toByteArray();
 
-                    Extension ext =
-                            new Extension(oid, isCritical, extValue);
+                    Extension ext = null;
+                    if (jssoid.equals(SKIoid)) {
+                        CMS.debug(method + "found SUBJECT_KEY_IDENTIFIER extension");
+                        ext = new SubjectKeyIdentifierExtension(false,
+                                jssext.getExtnValue().toByteArray());
+                    } else {
+                        new Extension(oid, isCritical, extValue);
+                    }
 
                     extensions.parseExtension(ext);
                 }
@@ -2042,12 +2151,12 @@ public abstract class EnrollProfile extends BasicProfile
                     DerInputStream extIn = new DerInputStream(extB);
                     CertificateExtensions exts = new CertificateExtensions(extIn);
                     if (exts != null) {
-                        CMS.debug(method + "Set extensions " + exts);
+                        CMS.debug(method + "PKCS10 found extensions " + exts);
                         // info.set(X509CertInfo.EXTENSIONS, exts);
                         req.setExtData(REQUEST_EXTENSIONS, exts);
                     }
                 } else {
-                    CMS.debug(method + "PKCS10 extension Not Found");
+                    CMS.debug(method + "PKCS10 no extension found");
                 }
             }
 
@@ -2406,7 +2515,7 @@ public abstract class EnrollProfile extends BasicProfile
         String method = "EnrollProfile: verifyPOP: ";
         CMS.debug(method + "for signing keys begins.");
 
-        String auditMessage = null;
+        String auditMessage = method;
         String auditSubjectID = auditSubjectID();
 
         if (!certReqMsg.hasPop()) {
@@ -2435,7 +2544,7 @@ public abstract class EnrollProfile extends BasicProfile
 
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                    AuditEvent.PROOF_OF_POSSESSION,
+                    AuditEvent.PROOF_OF_POSSESSION_SUCCESS,
                     auditSubjectID,
                     ILogger.SUCCESS);
             audit(auditMessage);
@@ -2446,19 +2555,21 @@ public abstract class EnrollProfile extends BasicProfile
         CMS.debug(method + "done.");
     }
 
-    private void popFailed(Locale locale, String auditSubjectID, String auditMessage)
+    private void popFailed(Locale locale, String auditSubjectID, String msg)
             throws EProfileException {
-        popFailed(locale, auditSubjectID, auditMessage, null);
+        popFailed(locale, auditSubjectID, msg, null);
     }
-    private void popFailed(Locale locale, String auditSubjectID, String auditMessage, Exception e)
+    private void popFailed(Locale locale, String auditSubjectID, String msg, Exception e)
             throws EProfileException {
 
+            if (e != null)
+                msg = msg + e.toString();
             // store a message in the signed audit log file
-            auditMessage = CMS.getLogMessage(
-                    AuditEvent.PROOF_OF_POSSESSION,
+            String auditMessage = CMS.getLogMessage(
+                    AuditEvent.PROOF_OF_POSSESSION_FAILURE,
                     auditSubjectID,
-                    ILogger.FAILURE);
-
+                    ILogger.FAILURE,
+                    msg);
             audit(auditMessage);
 
             if (e != null) {
diff --git a/base/server/cms/src/com/netscape/cms/profile/def/CAEnrollDefault.java b/base/server/cms/src/com/netscape/cms/profile/def/CAEnrollDefault.java
index 14484e0..635c044 100644
--- a/base/server/cms/src/com/netscape/cms/profile/def/CAEnrollDefault.java
+++ b/base/server/cms/src/com/netscape/cms/profile/def/CAEnrollDefault.java
@@ -25,6 +25,7 @@ import java.security.cert.CertificateException;
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.ca.ICertificateAuthority;
+import com.netscape.cmsutil.crypto.CryptoUtil;
 
 import netscape.security.x509.CertificateX509Key;
 import netscape.security.x509.KeyIdentifier;
@@ -46,30 +47,29 @@ public abstract class CAEnrollDefault extends EnrollDefault {
     }
 
     public KeyIdentifier getKeyIdentifier(X509CertInfo info) {
+        String method = "CAEnrollDefault: getKeyIdentifier: ";
         try {
             CertificateX509Key ckey = (CertificateX509Key)
                     info.get(X509CertInfo.KEY);
             X509Key key = (X509Key) ckey.get(CertificateX509Key.KEY);
-            MessageDigest md = MessageDigest.getInstance("SHA-1");
-
-            md.update(key.getKey());
-            byte[] hash = md.digest();
+            byte[] hash = CryptoUtil.generateKeyIdentifier(key.getKey());
+            if (hash == null) {
+                CMS.debug(method +
+                    "CryptoUtil.generateKeyIdentifier returns null");
+                return null;
+            }
 
             return new KeyIdentifier(hash);
         } catch (IOException e) {
-            CMS.debug("AuthorityKeyIdentifierExtDefault: getKeyId " +
-                    e.toString());
+            CMS.debug(method + e.toString());
         } catch (CertificateException e) {
-            CMS.debug("AuthorityKeyIdentifierExtDefault: getKeyId " +
-                    e.toString());
-        } catch (NoSuchAlgorithmException e) {
-            CMS.debug("AuthorityKeyIdentifierExtDefault: getKeyId " +
-                    e.toString());
+            CMS.debug(method + e.toString());
         }
         return null;
     }
 
     public KeyIdentifier getCAKeyIdentifier(ICertificateAuthority ca) throws EBaseException {
+        String method = "CAEnrollDefault: getCAKeyIdentifier: ";
         X509CertImpl caCert = ca.getCACert();
         if (caCert == null) {
             // during configuration, we dont have the CA certificate
@@ -89,16 +89,11 @@ public abstract class CAEnrollDefault extends EnrollDefault {
             }
         }
 
-        try {
-            MessageDigest md = MessageDigest.getInstance("SHA-1");
-
-            md.update(key.getKey());
-            byte[] hash = md.digest();
-
-            return new KeyIdentifier(hash);
-        } catch (NoSuchAlgorithmException e) {
-            CMS.debug("AuthorityKeyIdentifierExtDefault: getKeyId " +
-                    e.toString());
+        byte[] hash = CryptoUtil.generateKeyIdentifier(key.getKey());
+        if (hash == null) {
+            CMS.debug(method +
+                "CryptoUtil.generateKeyIdentifier returns null");
+            return null;
         }
         return null;
     }
diff --git a/base/server/cms/src/com/netscape/cms/profile/def/SubjectKeyIdentifierExtDefault.java b/base/server/cms/src/com/netscape/cms/profile/def/SubjectKeyIdentifierExtDefault.java
index a8f6a74..d787575 100644
--- a/base/server/cms/src/com/netscape/cms/profile/def/SubjectKeyIdentifierExtDefault.java
+++ b/base/server/cms/src/com/netscape/cms/profile/def/SubjectKeyIdentifierExtDefault.java
@@ -37,6 +37,7 @@ import com.netscape.certsrv.property.Descriptor;
 import com.netscape.certsrv.property.EPropertyException;
 import com.netscape.certsrv.property.IDescriptor;
 import com.netscape.certsrv.request.IRequest;
+import com.netscape.cmsutil.crypto.CryptoUtil;
 
 /**
  * This class implements an enrollment default policy
@@ -195,22 +196,26 @@ public class SubjectKeyIdentifierExtDefault extends EnrollExtDefault {
     }
 
     public KeyIdentifier getKeyIdentifier(X509CertInfo info) {
+        String method = "SubjectKeyIdentifierExtDefault: getKeyIdentifier: ";
         try {
             CertificateX509Key infokey = (CertificateX509Key)
                     info.get(X509CertInfo.KEY);
             X509Key key = (X509Key) infokey.get(CertificateX509Key.KEY);
-            MessageDigest md = MessageDigest.getInstance("SHA-1");
 
-            md.update(key.getKey());
-            byte[] hash = md.digest();
+            // "SHA-1" is default for CryptoUtil.generateKeyIdentifier.
+            // you could specify different algorithm with the alg parameter
+            // like this:
+            //byte[] hash = CryptoUtil.generateKeyIdentifier(key.getKey(), "SHA-256");
+            byte[] hash = CryptoUtil.generateKeyIdentifier(key.getKey());
 
+            if (hash == null) {
+                CMS.debug(method +
+                    "CryptoUtil.generateKeyIdentifier returns null");
+                return null;
+            }
             return new KeyIdentifier(hash);
-        } catch (NoSuchAlgorithmException e) {
-            CMS.debug("SubjectKeyIdentifierExtDefault: getKeyIdentifier " +
-                    e.toString());
         } catch (Exception e) {
-            CMS.debug("SubjectKeyIdentifierExtDefault: getKeyIdentifier " +
-                    e.toString());
+            CMS.debug(method + e.toString());
         }
         return null;
     }
diff --git a/base/server/cms/src/com/netscape/cms/profile/input/EnrollInput.java b/base/server/cms/src/com/netscape/cms/profile/input/EnrollInput.java
index 84a6398..7665006 100644
--- a/base/server/cms/src/com/netscape/cms/profile/input/EnrollInput.java
+++ b/base/server/cms/src/com/netscape/cms/profile/input/EnrollInput.java
@@ -179,6 +179,7 @@ public abstract class EnrollInput implements IProfileInput {
 
     public void verifyPOP(Locale locale, CertReqMsg certReqMsg)
             throws EProfileException {
+        String method = "EnrollInput: verifyPOP: ";
         CMS.debug("EnrollInput ::in verifyPOP");
 
         String auditMessage = null;
@@ -217,7 +218,7 @@ public abstract class EnrollInput implements IProfileInput {
 
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                    AuditEvent.PROOF_OF_POSSESSION,
+                    AuditEvent.PROOF_OF_POSSESSION_SUCCESS,
                     auditSubjectID,
                     ILogger.SUCCESS);
             audit(auditMessage);
@@ -228,9 +229,10 @@ public abstract class EnrollInput implements IProfileInput {
 
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                    AuditEvent.PROOF_OF_POSSESSION,
+                    AuditEvent.PROOF_OF_POSSESSION_FAILURE,
                     auditSubjectID,
-                    ILogger.FAILURE);
+                    ILogger.FAILURE,
+                    method + e.toString());
 
             audit(auditMessage);
 
diff --git a/base/server/cms/src/com/netscape/cms/servlet/processors/CRMFProcessor.java b/base/server/cms/src/com/netscape/cms/servlet/processors/CRMFProcessor.java
index 70a4a42..58cdd3c 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/processors/CRMFProcessor.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/processors/CRMFProcessor.java
@@ -98,6 +98,7 @@ public class CRMFProcessor extends PKIProcessor {
      */
     private void verifyPOP(CertReqMsg certReqMsg)
             throws EBaseException {
+        String method = "CRMFProcessor: verifyPOP: ";
         String auditMessage = null;
         String auditSubjectID = auditSubjectID();
 
@@ -116,7 +117,7 @@ public class CRMFProcessor extends PKIProcessor {
 
                         // store a message in the signed audit log file
                         auditMessage = CMS.getLogMessage(
-                                AuditEvent.PROOF_OF_POSSESSION,
+                                AuditEvent.PROOF_OF_POSSESSION_SUCCESS,
                                 auditSubjectID,
                                 ILogger.SUCCESS);
 
@@ -129,9 +130,10 @@ public class CRMFProcessor extends PKIProcessor {
 
                         // store a message in the signed audit log file
                         auditMessage = CMS.getLogMessage(
-                                AuditEvent.PROOF_OF_POSSESSION,
+                                AuditEvent.PROOF_OF_POSSESSION_FAILURE,
                                 auditSubjectID,
-                                ILogger.FAILURE);
+                                ILogger.FAILURE,
+                                method + e.toString());
 
                         audit(auditMessage);
 
@@ -146,9 +148,10 @@ public class CRMFProcessor extends PKIProcessor {
 
                     // store a message in the signed audit log file
                     auditMessage = CMS.getLogMessage(
-                            AuditEvent.PROOF_OF_POSSESSION,
+                            AuditEvent.PROOF_OF_POSSESSION_FAILURE,
                             auditSubjectID,
-                            ILogger.FAILURE);
+                            ILogger.FAILURE,
+                            method + "required POP missing");
 
                     audit(auditMessage);
 
@@ -159,9 +162,10 @@ public class CRMFProcessor extends PKIProcessor {
         } catch (EBaseException eAudit1) {
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                    AuditEvent.PROOF_OF_POSSESSION,
+                    AuditEvent.PROOF_OF_POSSESSION_FAILURE,
                     auditSubjectID,
-                    ILogger.FAILURE);
+                    ILogger.FAILURE,
+                    method + eAudit1.toString());
 
             audit(auditMessage);
         }
diff --git a/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java b/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
index 1e128d0..a1b01f4 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
@@ -39,12 +39,16 @@ import org.mozilla.jss.pkix.cmc.OtherInfo;
 import org.mozilla.jss.pkix.cmc.TaggedAttribute;
 
 import com.netscape.certsrv.apps.CMS;
+import com.netscape.certsrv.authentication.EInvalidCredentials;
+import com.netscape.certsrv.authentication.EMissingCredential;
 import com.netscape.certsrv.authentication.IAuthManager;
 import com.netscape.certsrv.authentication.IAuthToken;
 import com.netscape.certsrv.authorization.AuthzToken;
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.base.SessionContext;
 import com.netscape.certsrv.logging.ILogger;
+import com.netscape.certsrv.logging.event.AuthFailEvent;
+import com.netscape.certsrv.logging.event.AuthSuccessEvent;
 import com.netscape.certsrv.logging.event.CertRequestProcessedEvent;
 import com.netscape.certsrv.profile.EDeferException;
 import com.netscape.certsrv.profile.EProfileException;
@@ -143,6 +147,7 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
 
     public IAuthToken authenticate(IProfileAuthenticator authenticator,
             HttpServletRequest request) throws EBaseException {
+        String method = "ProfileSubmitCMCServlet: authenticate: ";
         AuthCredentials credentials = new AuthCredentials();
 
         // build credential
@@ -158,15 +163,47 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
                     credentials.set(authName, request.getParameter(authName));
             }
         }
-        IAuthToken authToken = authenticator.authenticate(credentials);
 
+        IAuthToken authToken = null;
+        String auditSubjectID = null;
+        String authMgrID = authenticator.getName();
         SessionContext sc = SessionContext.getContext();
-        if (sc != null) {
-            sc.put(SessionContext.AUTH_MANAGER_ID, authenticator.getName());
-            String userid = authToken.getInString(IAuthToken.USER_ID);
-            if (userid != null) {
-                sc.put(SessionContext.USER_ID, userid);
+
+        try {
+            authToken = authenticator.authenticate(credentials);
+            if (sc != null) {
+                sc.put(SessionContext.AUTH_MANAGER_ID, authMgrID);
+                auditSubjectID = authToken.getInString(IAuthToken.USER_ID);
+                if (auditSubjectID != null) {
+                    CMS.debug(method + "setting auditSubjectID in SessionContext:" +
+                            auditSubjectID);
+                    sc.put(SessionContext.USER_ID, auditSubjectID);
+                } else {
+                    CMS.debug(method + "no auditSubjectID found in authToken");
+                }
+            }
+
+            if (!auditSubjectID.equals(ILogger.UNIDENTIFIED) &&
+                    !auditSubjectID.equals(ILogger.NONROLEUSER)) {
+                audit(new AuthSuccessEvent(
+                        auditSubjectID,
+                        ILogger.SUCCESS,
+                        authMgrID));
+            }
+
+        } catch (EBaseException e) {
+            CMS.debug(method + e);
+            String attempted_auditSubjectID = null;
+            if (sc != null) {
+                attempted_auditSubjectID =
+                        (String) sc.get(SessionContext.USER_ID);
             }
+            audit(new AuthFailEvent(
+                    auditSubjectID,
+                    ILogger.FAILURE,
+                    authMgrID,
+                    attempted_auditSubjectID));
+            throw(e);
         }
 
         return authToken;
diff --git a/base/server/cmscore/src/com/netscape/cmscore/security/KeyCertUtil.java b/base/server/cmscore/src/com/netscape/cmscore/security/KeyCertUtil.java
index 6dabd0c..177d540 100644
--- a/base/server/cmscore/src/com/netscape/cmscore/security/KeyCertUtil.java
+++ b/base/server/cmscore/src/com/netscape/cmscore/security/KeyCertUtil.java
@@ -1032,13 +1032,17 @@ public class KeyCertUtil {
 
     public static KeyIdentifier createKeyIdentifier(KeyPair keypair)
             throws NoSuchAlgorithmException, InvalidKeyException {
-        MessageDigest md = MessageDigest.getInstance("SHA-1");
         X509Key subjectKeyInfo = convertPublicKeyToX509Key(
                 keypair.getPublic());
 
-        //md.update(subjectKeyInfo.getEncoded());
-        md.update(subjectKeyInfo.getKey());
-        return new KeyIdentifier(md.digest());
+        byte[] hash = CryptoUtil.generateKeyIdentifier(subjectKeyInfo.getKey());
+
+        if (hash == null) {
+            CMS.debug("KeyCertUtil: createKeyIdentifier " +
+                "CryptoUtil.generateKeyIdentifier returns null");
+            return null;
+        }
+        return new KeyIdentifier(hash);
     }
 
     public static BigInteger getSerialNumber(LDAPConnection conn, String baseDN)
